﻿Public Class Base
    '他のクラスの基本形
    'プロパティーは、x, y, z座標, 存在フラグ(exist), クラス内での分類(kind), 表示されるものの大きさ(size)

    '座標↓
    'x, y座標は画像の左上相当
    Private _x As Integer     '座標_x（coordinate）

    Public Property x() As Integer
        Get
            Return _x
        End Get
        Set(ByVal value As Integer)
            _x = value
        End Set
    End Property

    Private _y As Integer     '座標_y（coordinate）

    Public Property y() As Integer
        Get
            Return _y
        End Get
        Set(ByVal value As Integer)
            _y = value
        End Set
    End Property

    Private _z As Integer     '座標_z（coordinate）

    Public Property z() As Integer
        Get
            Return _z
        End Get
        Set(ByVal value As Integer)
            _z = value
        End Set
    End Property

    '存在フラグ
    Private _exist As Boolean   '存在する:true, 存在しない:false

    Public Property exist() As Boolean
        Get
            Return _exist
        End Get
        Set(ByVal value As Boolean)
            _exist = value
        End Set
    End Property

    'クラス内での分類用
    Private _kind As Integer

    Public Property kind() As Integer
        Get
            Return _kind
        End Get
        Set(ByVal value As Integer)
            _kind = value
        End Set
    End Property

    '表示サイズじゃなくて、ゲーム内での大きさ
    Private _size As Integer

    Public Property size() As Integer
        Get
            Return _size
        End Get
        Set(ByVal value As Integer)
            _size = value
        End Set
    End Property


    '入力用関数
    Public Sub set_c(ByVal in_x As Integer, ByVal in_y As Integer, ByVal in_z As Integer)

        Me.x = in_x
        Me.y = in_y
        Me.z = in_z

    End Sub

    '描画関数補助用

    Public Function vir_size(ByVal z As Integer, ByVal size As Integer) As Integer '画面上でのsizeを返す
        Dim v_size As Integer

        v_size = size * (c.ratio * c.z_max + (1 - c.ratio) * z) \ (c.ratio * c.z_max)

        Return v_size

    End Function

    Public Function wid_x(ByVal z As Integer) As Integer '引数のz座標におけるxの両端間距離が画面上の大きさではいくつかを返す
        Dim w_x As Integer

        w_x = c.x_max * (c.ratio * c.z_max + (1 - c.ratio) * z) \ (c.ratio * c.z_max)

        Return w_x

    End Function

    Public Function vir_x(ByVal x As Integer, ByVal z As Integer) As Integer '画面上でのx座標を返す
        Dim v_x As Integer

        v_x = (c.x_max * (c.ratio * c.z_max) + (2 * x - c.x_max) * (c.ratio * c.z_max + (1 - c.ratio) * z)) \ (2 * c.ratio * c.z_max)

        Return v_x

    End Function

    Public Function vir_y(ByRef y As Integer, ByRef z As Integer, ByVal size As Integer) As Integer '画面上でのy座標を返す
        Dim v_y As Integer

        v_y = (c.win_size - c.y_max) + c.y_max * (c.z_max - z) \ c.z_max - ((c.y_max - size) - y) * (c.ratio * c.z_max + (1 - c.ratio) * z) \ (c.ratio * c.z_max) - vir_size(z, size)

        Return v_y

    End Function


    Private Shared g_b As Graphics = Graphics.FromImage(Drawing.campus)  '描画に使う
    Dim b As New SolidBrush(Color.FromArgb(0, 0, 0))  '影の描画用に

    'キャラクター、弾などの描画関数
    Public Sub draw(ByVal img As Bitmap)
        If Me.exist Then    '存在フラグがたっている場合のみ描画する
            '影を描く
            g_b.FillEllipse(b, vir_x(Me.x, Me.z),
                          vir_y(c.y_max - Me.size, Me.z, Me.size) + (3 * vir_size(Me.z, Me.size)) \ 4,
                          vir_size(Me.z, Me.size),
                          vir_size(Me.z, Me.size) \ 2)
            '自分を描画
            g_b.DrawImage(img,
                        vir_x(Me.x, Me.z),
                        vir_y(Me.y, Me.z, Me.size),
                        vir_size(Me.z, Me.size),
                        vir_size(Me.z, Me.size))
        End If

    End Sub
End Class


