﻿Public Class Base2  '弾の基本(小数-整数間のずれで、きれいに弾幕できないので分けました)
    Inherits Base

    '小数部分が失われると円形の弾幕とかが作れないのでsingleで

    Private _vec_x As Single   '速度ベクトル_x

    Public Property vec_x() As Single
        Get
            Return _vec_x
        End Get
        Set(ByVal value As Single)
            _vec_x = value
        End Set
    End Property

    'yベクトルはそんなに気にしなくてもあんまりわからないのでintegerで行きます
    Private _vec_y As Integer   '速度ベクトル_y

    Public Property vec_y() As Integer
        Get
            Return _vec_y
        End Get
        Set(ByVal value As Integer)
            _vec_y = value
        End Set
    End Property

    Private _vec_z As Single   '速度ベクトル_z

    Public Property vec_z() As Single
        Get
            Return _vec_z
        End Get
        Set(ByVal value As Single)
            _vec_z = value
        End Set
    End Property

    Private _rem_x As Single   '速度ベクトル_xの、移動しそこなった残り

    Public Property rem_x() As Single
        Get
            Return _rem_x
        End Get
        Set(ByVal value As Single)
            _rem_x = value
        End Set
    End Property

    Private _rem_z As Single   '速度ベクトル_zの、移動しそこなった残り

    Public Property rem_z() As Single
        Get
            Return _rem_z
        End Get
        Set(ByVal value As Single)
            _rem_z = value
        End Set
    End Property

    Private _action As Integer   '動作の分類用

    Public Property action() As Integer
        Get
            Return _action
        End Get
        Set(ByVal value As Integer)
            _action = value
        End Set
    End Property

    Public Sub New()
        Me.x = 0
        Me.y = 0
        Me.z = 0
        Me.vec_x = 0
        Me.vec_y = 0
        Me.vec_z = 0
        Me.rem_x = 0
        Me.rem_z = 0
        Me.exist = False
        Me.kind = 0
        Me.size = 0
        Me.action = 0
    End Sub

    Public Sub disappear()
        Me.x = 0
        Me.y = 0
        Me.z = 0
        Me.vec_x = 0
        Me.vec_y = 0
        Me.vec_z = 0
        Me.rem_x = 0
        Me.rem_z = 0
        Me.exist = False
        Me.kind = 0
        Me.size = 0
        Me.action = 0
    End Sub

    Public Sub set_v(ByVal in_vec_x As Single, ByVal in_vec_y As Integer, ByVal in_vec_z As Single)

        Me.vec_x = in_vec_x
        Me.vec_y = in_vec_y
        Me.vec_z = in_vec_z

    End Sub
    Public Sub set_s(ByVal in_exist As Boolean, ByVal in_kind As Integer, ByVal in_size As Integer, ByVal in_action As Integer)

        Me.exist = in_exist   '存在フラグ
        Me.kind = in_kind     '種類
        Me.size = in_size   '大きさ
        Me.action = in_action   '動作判別用

    End Sub

    Public Sub move_base()
        '各軸方向の速度を座標に反映、用は動かすよってことで

        'vecの整数部分を取り出す(x, zだけ)
        Dim i_x As Integer = Fix(Me.vec_x)
        Dim i_z As Integer = Fix(Me.vec_z)

        '取り出した整数部で座標を更新(yはそのまま)
        Me.x += i_x
        Me.y += Me.vec_y
        Me.z += i_z

        '使われなかった小数部をremに貯蓄(x, zだけ)
        Me.rem_x += Me.vec_x - CDbl(i_x)
        Me.rem_z += Me.vec_z - CDbl(i_z)

        'remにたまった小数部たちが整数部を取り出せるまでたまったら取り出す(x, zだけ)
        i_x = Fix(Me.rem_x)
        i_z = Fix(Me.rem_z)

        '昔つかわれなかった分をここで出す(x, zだけ)
        Me.x += i_x
        Me.z += i_z

        '座標更新に使った分は減らしておく(x, zだけ)
        Me.rem_x -= CDbl(i_x)
        Me.rem_z -= CDbl(i_z)

    End Sub

    Public Sub gravity()
        
        '重力的な動作、床との反射を担当
        If Me.exist Then
            Select Case Me.action
                Case 0
                    'y座標は...いいや。丸め誤差なんか知らない(~3~)
                    If Me.y + size + Me.vec_y < c.y_max Then    '地面に足がついてなかったら
                        If Me.vec_y < 30 Then   '重力による最大加速は50まで
                            Me.vec_y += 2 'これが重力加速度ってやつ
                        Else
                            Me.vec_y = 30     '落下で加速してもこれ以上速くならないよー
                        End If
                    Else    '地面に足がついたorめり込んだとき
                        Me.y = c.y_max - Me.size    'y座標の下端に画像の下端が合うように
                        If Me.vec_y > 0 Then   '地面にぶつかった
                            Me.vec_y = -3 * (Math.Abs(Me.vec_y) \ 4) '速度を3/4減して反射、だんだん落ち着いてくる
                            If Me.kind = 13 Then   '(炎の弾)s_sizeだと小さいし、m_sizeだと大きすぎる感じがしたんでサイズ20に
                                Bullet.set_circle(Me.x, c.y_max - 20, Me.z, 13, 20, 15, 0, 32, 0)  '地面に落下すると円形に散る
                                Me.disappear()
                            End If
                            If Me.kind = 14 Then   '5面ボスの弾
                                Me.action = 2
                                Me.set_v(0, 0, 0)  '地面に刺さって止まる
                            End If
                        End If
                    End If
                Case 1
                    If Me.y + Me.size > c.y_max Then
                        Me.disappear()
                    End If
                Case 2 To 200
                    action += 1
                    If Me.kind = 11 Then
                        If Me.action = 30 Then
                            If Me.z > c.boss.z Then  '全部手前に撒くようにボスより奥と手前で分ける
                                Dim theta As Single = Math.Atan2(Me.z - (c.boss.z + 200), Me.x - (c.boss.x + c.boss.size \ 2))
                                Me.set_v((5 + Me.y \ 100) * Math.Cos(theta), 0, -5 + (Me.y \ 50) * Math.Sin(theta))
                                Me.action = 0
                            Else
                                Dim theta As Single = Math.Atan2(Me.z - c.boss.z, Me.x - (c.boss.x + c.boss.size \ 2))
                                Me.set_v((5 + Me.y \ 100) * Math.Cos(theta), 0, -5 + (Me.y \ 50) * Math.Sin(theta))
                                Me.action = 0
                            End If
                        End If
                    ElseIf Me.kind = 14 Then   '角は200フレームで消える
                        If Me.action = 200 Then
                            Me.disappear()
                        End If
                    End If
            End Select
        End If

    End Sub
End Class
